#include <iostream>
#include <cstring>

using namespace std;
class Disposition;
	
class Boss 
{
	public:
		Boss();
		void helpMe();
		void directMe();
		char* getMood();
	private:
		Disposition*  mood;
		void changeMood();
};

class Disposition 
{
	public:
		virtual ~Disposition(){};
		virtual void helpMe() = 0;
		virtual void directMe() = 0;
		virtual Disposition* changeMood() = 0;
		char* getMood(){ return moodText; }
	protected:
		char moodText[5];
};

class BadMood : public Disposition 
{ 
	public:
		BadMood();
		void helpMe();
		void directMe();
		Disposition* changeMood();
};

class OkMood : public Disposition
{
	public:
		OkMood();
		void helpMe();
		void directMe();
		Disposition* changeMood();
};

class GoodMood : public Disposition
{
	public:
		GoodMood();
		void helpMe();
		void directMe();
		Disposition* changeMood();
};


/** BOSS BOSS BOSS */

Boss :: Boss() 
{
	mood = new OkMood;
}

void Boss :: helpMe() 
{
	mood->helpMe(); 
}

void Boss :: directMe() 
{
	mood->directMe(); 
	changeMood();
}

char* Boss :: getMood()
{
	return mood->getMood();
}

void Boss :: changeMood()
{
	Disposition* oldMood = mood;
	mood = mood->changeMood();
	delete oldMood;
}

		
/** BAD MOOD*/		
BadMood :: BadMood() : Disposition()
{
	strcpy(moodText,"BAD");
}

void BadMood :: helpMe()
{ 
	cout << "Help yourself!" << endl; 
}

void BadMood :: directMe()
{
	cout << "Look on the map yourself!" << endl;
}

Disposition* BadMood :: changeMood()
{
	return new OkMood;
}

/** OK MOOD */
OkMood :: OkMood():Disposition()
{
	strcpy(moodText,"OK");
}

void OkMood :: helpMe() 
{
	cout << "How can I help you?" << endl; 
}

void OkMood :: directMe() 
{ 
	cout << "Let me show you on the map" << endl;
}

Disposition* OkMood :: changeMood()
{
	return new GoodMood;
}

/** GOOD MOOD */
GoodMood :: GoodMood():Disposition()
{
	strcpy(moodText,"GOOD");
}

void GoodMood :: helpMe() 
{
	cout << "Give it here i'll do it for you" << endl; 
}

void GoodMood :: directMe() 
{ 
	cout << "Please follow me" << endl;
}

Disposition* GoodMood :: changeMood()
{
	return new BadMood;
}

/**  MAIN */

int main() 
{   
	int choice = 1;
	Boss theBoss; 
	
	while(choice != 0)
	{
		cout << "THE BOSS'S MOOD IS " << theBoss.getMood() << endl;
		cout << "0. Quit" << endl ;
		cout << "1. Ask boss to help with a task" << endl;
		cout << "2. Ask boss for directions" << endl;
		cout << "Enter your choice: ";
		cin >> choice;
		cout << endl;
		switch(choice)
		{
			case 0 : break;
			case 1 : theBoss.helpMe(); break;
			case 2 : theBoss.directMe(); break;
			default : cout << "Invalid menu option" << endl;
		}
		cout << endl;
	}
	return 0;
}
